(*
 * Copyright (c) Meta Platforms, Inc. and affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *)

let instantiate_path ~build_system ~ast_environment qualifier =
  match Analysis.AstEnvironment.ReadOnly.get_real_path ast_environment qualifier with
  | None -> None
  | Some analysis_path ->
      let path =
        match BuildSystem.lookup_source build_system analysis_path with
        | Some source_path -> source_path |> SourcePath.raw
        | None ->
            (* NOTE (grievejia): This means the path is under the search roots but is not tracked by
               Buck. Showing the original path here is a compromise: ideally we should instead look
               into configuring Buck-built project in such a way that all source files are tracked
               by Buck. *)
            ArtifactPath.raw analysis_path
      in
      Some (PyrePath.absolute path)
